#include <iostream>
using namespace std;

#include <TApplication.h>
#include <TObject.h>
#include <TQObject.h>
#include <RQ_OBJECT.h>
#include <TCanvas.h>
#include <TPaveText.h>
#include <TString.h>

//------------------------------------------------------------------------
class TKeyTest
{
  RQ_OBJECT("TKeyTest")

  public:
    TKeyTest();
    virtual ~TKeyTest();

    void PrintKey(Int_t);

  private:
    TCanvas   *fCanvas;
    TPaveText *fInfo;
};

//------------------------------------------------------------------------
TKeyTest::TKeyTest()
{
  fCanvas = 0;
  fInfo   = 0;

  fCanvas = new TCanvas("fCanvas", "my Canvas", 900, 10, 300, 600);

  fInfo = new TPaveText(0.1, 0.1, 0.3, 0.2, "rb");
  fInfo->AddText("none");
  fInfo->Draw();

  fCanvas->Show();
}

//------------------------------------------------------------------------
TKeyTest::~TKeyTest()
{
  if (fInfo) {
    delete fInfo;
  }
  if (fCanvas) {
    delete fCanvas;
  }
}

//------------------------------------------------------------------------
void TKeyTest::PrintKey(Int_t key)
{
  if (key == 'q')
    gApplication->Terminate();

  TString str((Char_t)key);

  if (fInfo) {
    delete fInfo;
    fInfo = 0;
    fInfo = new TPaveText(0.1, 0.1, 0.3, 0.2, "rb");
    fInfo->AddText(str.Data());
    fInfo->Draw();
  }

  fCanvas->Update();
}

//------------------------------------------------------------------------
void test_key_pressed()
{
  TKeyTest *keyTest = new TKeyTest();

  gApplication->Connect("KeyPressed(Int_t)","TKeyTest",keyTest,"PrintKey(Int_t)");
}

//---- Main program ------------------------------------------------------------
#ifdef STANDALONE
int main(int argc, char **argv)
{
   TApplication theApp("App", &argc, argv);

   test_key_pressed();

   theApp.Run();

   return 0;
}
#endif
